#!/usr/bin/python
from wifi.wifi import *
import ecore.evas
import ecore
import sys
import etk

LABELFONTSIZE="<font_size=16>"
ITEMFONTSIZE="<font_size=32>"
SUBFONTSIZE="<font_size=16>"
def text_clicked(row):
    print "Clicked in item", row

def label_text(ap):
    return ITEMFONTSIZE + ap.essid_get() +"<br>" + SUBFONTSIZE + "Quality: "+ap.quality_get() +"%"

def update_status(lab):
    ans= LABELFONTSIZE + "<b>device:</b>   "+wifi.device+"<br>"
    ans+="<b>Access Point:</b>   "+wifi.APmac+"<br>"
    ans+="<b>Essid:</b>   " + wifi.essid_get() + "<br>"
    ans+="<b>IP:</b>   " + wifi.ip_get() + "<br>"
    if wifi.connection_check():
        ans += "<b>Connected!!</b>"
    else:
        ans += "<b>Not Connected Yet!!</b>"
    lab.text = ans
    return 1

def put_a_mask(wid):
    canvas=etk.Canvas.toplevel_evas_get(wid)
    mask=canvas.Rectangle(color=(0, 0, 0, 255))
    mask.pos=(0,0)
    mask.size=canvas.size
    mask.show()
    return mask
	
def remove_mask(mask):
    mask.hide()
    mask.delete()

def connect_to_AP_confirm(AP,lst):
    # for now always answer yes
    return True

def kill_udhcpc_timer():
    os.system("killall udhcpc");
    return 0

def connect_to_AP(AP):
    print "Connecting to "+AP.name
    wifi.essid_set(AP.name);
    print "Trying to get IP"
    wifi.dhcp()
    ecore.timer_add(60,kill_udhcpc_timer)
    update_status(lab)


def connect_button_clicked(b):
    print "button clicked " 
    r = lst.selected_rows
    if r:
	AP=r[0][0]
	print "Try to action label " + r[0][1]
	#connect_to_AP_confirm(AP,lst)
	connect_to_AP(AP)


def update_list(lst,wifi):
    AP=wifi.scan_ap()
    for row in lst.rows:
        row[2] = row[2]-1;
    for ap in AP:
        found=0
        for row in lst.rows:
            if ap.name == row[0].name:
                row[0]=ap
                row[1]=label_text(ap)
                found=1
        if found==0 and ap.openness_get():
            lst.freeze()
            model.append([ap, label_text(ap), 5]);
            lst.thaw()
    for row in lst.rows:
        if row[2] <= 0:
            lst.freeze()
            lst.rows.remove(row);
            lst.thaw()
    return 1



def init_gui():
    bottom_box = etk.HBox();
    connect_button = etk.Button(label="Connect");
    bottom_box.append(connect_button, etk.HBox.START , etk.HBox.EXPAND_FILL, 0)
    model = etk.ListModel()
    ktr = etk.KineticTextRenderer(slot=1, click=text_clicked)
    lst = etk.List(model, selectable=True, animated_changes=True,row_height=60, columns=[(480,ktr,True)])
    lab = etk.Label(text="Waiting for updating");
    main_box = etk.VBox();
    main_box.append(lab,etk.VBox.START, etk.VBox.FILL, 0);
    main_box.append(lst,etk.VBox.START, etk.VBox.EXPAND_FILL, 0);
    main_box.append(bottom_box,etk.VBox.START, etk.VBox.FILL, 0)
    w = etk.Window(title="Connect Wifi", size_request=(480, 300), child=main_box)
    w.on_destroyed(lambda x: etk.main_quit())
    w.show_all();
    return connect_button, lst, model, lab, w;


connect_button, lst, model, lab, window= init_gui()
if sys.argv.__len__() >= 2 and sys.argv[1] :
    device=sys.argv[1]
else:
    device="eth0"
wifi = wifi(device)

update_list(lst,wifi)

update_status(lab)
ecore.timer_add(5,update_status,lab)
ecore.timer_add(10,update_list,lst,wifi)
connect_button.on_clicked(connect_button_clicked);
etk.main();
