import os
import re
import codecs
import sys

sys.stdout = codecs.getwriter('utf-8')(sys.stdout)

def debug(str):
    print str
    pass

class AP:
    def __init__(self, name="default"):
        self.name=name
        self.wep_flag=True
        self.wpa_flag=True
        self.mode="Master"
        self.quality=0
        self.ip=""
        self.dns=""
        self.gw=""
    def essid_set(self,name):
	self.name=name

    def essid_get(self):
	return self.name
	
    def openness_set(self,wep,wpa):
	self.wep_flag=wep;
	self.wpa_flag=wpa;

    def openness_get(self):
	return not ( self.wep_flag or self.wpa_flag )

    def quality_set(self,value):
	self.quality = value;

    def quality_get(self):
	return self.quality 


class wifi:
    def __init__(self, device="eth0"):
	self.device = device
	self.APs=[]
	debug("device is " + self.device)
	self.turn_on()
        self.APmac=""

    def scan_ap(self):
	self.APs=[]
	list=os.popen("iwlist "+self.device+" scanning")
	line = list.readline();
	while line != "":
	    line = list.readline()
	    # Creating a new AP
	    match=re.match("\s*Cell \d*",line)
	    if match:
		debug("Get a new cell" + match.group(0))
		aa=AP();
	    # Get essid
	    match=re.match("(\s*)ESSID:\"(\S*)\"",line);
	    if match:
		debug("The essid of this AP is "+match.group(2))
		aa.essid_set(match.group(2));
	    match=re.match("\s*Encryption key:off",line);
	    if match:
		debug("This AP is open!! ^^");
		aa.openness_set(False,False);
	    match=re.match("\s*Quality=(\d*)/(\d*)",line);
	    if match:
		debug("The Quality is "+match.group(1));
		aa.quality_set(match.group(1))
		self.APs.append(aa);
	list.close()
	return self.APs

    def essid_set(self,essid):
	os.system("iwconfig " + self.device + " essid " + essid);
	pass

    def essid_wep_key_set(self, essid, key):
	os.system("iwconfig " + self.device + " essid \"" + essid + "\" key \"" + key + "\"");
	pass
    def essid_get(self):
	ans = os.popen("iwconfig "+self.device)
	essid=""
	line = ans.readline()
	while line != "":
	    #eth0      AR6000 802.11g  ESSID:"Openlab"
	    match=re.match("\S*\s*\S*\s*\S*\s*ESSID:\"(\S*)\"",line)
	    if match:
	        essid = match.group(1)
            #Mode:Managed  Frequency=nan kHz  Access Point: Not-Associated
            match=re.match("\s*Mode\S*\s*\S*\s*\S*\s*Access Point: (\S*)",line);
            if match:
                print "AP mac: "+match.group(1)
                self.APmac = match.group(1)
	    line = ans.readline();
	ans.close()
	return essid
    def ip_get(self):
	ans = os.popen("ifconfig "+self.device);
	ip="";
	line = ans.readline();
	while line != "":
	    match = re.match("\s*inet addr:(\S*)  Bcast:\S*  Mask:\S*",line);
	    if match:
		ip = match.group(1);
		break;
	    line = ans.readline();
	ans.close()
	self.ip = ip;
	return self.ip;
    def ip_set(self,ip):
	os.system("ifconfig "+self.device+" "+ip);
    def turn_on(self):
	os.system("iwconfig " + self.device + " txpower 100");
	pass
    def turn_off(self):
	os.system("iwconfig " + self.device + " txpower 0");
	pass
    def dhcp(self):
	os.system("killall -9 udhcpc;sleep 3");
        os.system("route del default");
	os.system("udhcpc -i "+self.device+ " &")

    def guess_best_ap(self):
	max=int(0)
	for ap in self.APs:
	    if ap.openness_get() and int(ap.quality_get()) > int(max):
		max_ap =  ap
		max    =  int(ap.quality_get())
	if "max_ap" in dir():
	    return max_ap
	return None

    def connection_check(self):
        if self.ip != "" and self.APmac != "":
            return True
        return False

